# DMP creado por César López Bermúdez
# Fecha 15/10/2018

import streams
import json
from nxp.hexiwear import hexiwear
import InitDMP as dmp
import queue
import screen
import org1411 as gps

from ublox.g350 import g350
from wireless import gsm
#import requests
#import json

from ibmcloud.iot import iot
import helpers
import timers

####### Código principal

## Inicialización comm serie
streams.serial()
sleep(1000)




fifo_screen = queue.Queue(maxsize=20)
new_resource('device.conf.json')
new_resource('sensor.conf.json')

device_conf = helpers.load_device_conf()    

device = iot.Device(device_conf['device_id'], device_conf['device_type'], device_conf['organization'], device_conf['auth_token'])


## Inicialización de dispositivo Hexiwear

print("Creando objeto Hexiwear")

hexi = hexiwear.HEXIWEAR(battery_en=True, oled_en=True, amb_light_en=True, heart_rate_en=False,
                        temp_humid_en=True, gyro_en=True, acc_magn_en=True, pressure_en=True,
                        bt_driver_en=False)


def gps_connect():
    try:
    
        # init gps module
        drv_gps = SERIAL3
        pwr_gps = D15
        wup_gps = D12
        
        print("init gps")
    
    
        gps.init(drv_gps, pwr_gps, wup_gps)
        sleep(3000)
        print("listo gps")
        for i in range(20):
            # retrieve global position
            print("- - - - - - - - - Intento ",i)
            res = gps.get_pos()
            if res != 0:
                lat, lon, alt = res
                print("latitud = %+10.6f" % lat)
                print("longitud = %+011.6f" % lon)
                print("altitud= %.1f" % alt)
                sleep(5000)
            sleep(1000)
            
    except Exception as e:
        print(e)
    return res
    
def GSM_Connect():

    """

.. py:function:: GSM_Connect()
    
    Realiza la conexión GSM a la red via G350
    Retorna código (OK = 0, ERR = -1)
    """
 

    ret_err = g350.init(SERIAL2,D19,D2,D0,D20)
    
    sleep(1000)
    
    for i in range(20):
        try:
        # set here the APN name
            gsm.attach('Internet')
            break
        except g350Exception:
            print("lksdf")
        except TimeoutError:
            print("lj")
        sleep(2000)    
    else:
        print("fds")
        while True:
            sleep(1000)
    
    return 0

def IBMCloud_Connect():
    try:
        print('connecting to mqtt broker...')
        device.mqtt.connect()
    except Exception as err:
        return -1
    return 0

# Funciones para Callback del NCG
# Carga de configuración

def config_call(msg):
    global sens_config
    sens_config = msg
    
def medic_call(med):
    global med_msg
    med_msg = med
    
def cita_call(cita):
    global cita_msg
    cita_msg = cita
    
def activ_call(activ):
    global activ_msg
    activ_msg = activ
    
# Carga de configuración predeterminada
sens_config = helpers.sensor_conf()
med_msg = {}
cita_msg = {}
activ_msg = {}

dmp.init_settings(hexi)
sleep(1000)

thread(screen.main_thread,fifo_screen,hexi)


### fin coments

# Lanzar Icono GSM
fifo_screen.put(['GSM_Con','0'])

for _ in range(10):
    return_connect = GSM_Connect()
    if return_connect == 0:
        break
else:
    fifo_screen.put(['Tech_Fail','0'])

# Retira mensaje GSM
fifo_screen.put(['GSM_Con','0'])

# Lanza GSM_UP en barra superior de estado

fifo_screen.put(['GSM_UP','0'])

## Realización de la conexión de arranque inicial.
## Se exige que esta conexión se realice, en caso
## Contrario se supone avería y se demanda servicio
## Técnico

# Tomar hora y fecha de Internet


### Conexión con IBMCloud IoT
### Envío del mensaje de arranque

fifo_screen.put(['MQTT_Con','0'])

fifo_screen.put(['Tech_Fail','0']) if  IBMCloud_Connect() == -1 else fifo_screen.put(['CLOUD_UP','0'])
sleep(2000)

fifo_screen.put(['MQTT_Con','0'])

#Referencia de funciones para calkbacks
device.on_cmd('init', config_call)
device.on_cmd('medi', medic_call)
device.on_cmd('cita', cita_call)
device.on_cmd('acti', activ_call)


device.mqtt.loop()
print("inicializado Loop MQTT")

while 1:
    # Loop principal
    dict_sensors = dmp.get_sensors(hexi,sens_config)
    sleep(500)
    
    # comprobar callbacks y mostrar datos en pantalla Hexiwear
    if cita_msg:
        fifo_screen.put(['cita',cita_msg['Medicina']])
        cita_msg = {}
    if med_msg:
        fifo_screen.put(['med',med_msg['fecha']])
        med_msg = {}
    if activ_msg:
        fifo_screen.put(['activ',activ_msg['Nivel']])
        activ_msg = {}

        
    # Comprobar posibles alarmas locales
    print("Loop Main\n\n",sens_config) #, dict_sensors)
    sleep(500)
    
    if dict_sensors['temperature'] <= 2:
        print("FRIIIIO\n")
        fifo_screen.put(['Temp_Low','0'])
        hexi.vibration(200)
        sleep(300)
        fifo_screen.put(['Temp_Low','0'])
         
    if dict_sensors['temperature'] > 32:
        print("CALORRRR\n")
        fifo_screen.put(['Temp_High','0'])
        hexi.vibration(200)
        sleep(300)
        fifo_screen.put(['Temp_High','0'])
    
    # adición de información de GSM al diccionario
    #RSSI
    dict_sensors['GSM_rssi'] = gsm.rssi()
    net_info = gsm.network_info()
    # Guarda la estación base
    dict_sensors['GSM_node'] = net_info[3]
    
    # Control de Batería
    fifo_screen.put(['Bateria', str(dict_sensors['bat_level'])])
    
    # Comprobar si config exige gps
    if sens_config["GPS"] == "on":
        total = gps_connect()
        latit, long, alti = total
        dict_sensors['GPS_lat'] = latit
        dict_sensors['GPS_long'] = long

    
    #device.publish('main', json.dumps(dict_sensors))

    #Establecimiento del período de muestreo
    sleep(int(sens_config['tglobal']))


    